<template>
  <div class="group-block">
    <div
      v-if="isFirstElementInTree()"
      class="not_dragging"
      :class="{ dragging: showDropTarget() }"
      v-on:dragenter="dragEnterHandler($event)"
      v-on:dragleave="dragLeaveHandler($event)"
      v-on:dragover="dragOverHandler($event)"
      v-on:drop="dropHandler($event, 'before')"
    ></div>
    <div
      draggable="true"
      class="group-header"
      v-on:dragstart="dragstartHandler($event)"
      v-on:dragend="dragendHandler($event)"
      v-on:dragenter="dragEnterHandler($event)"
      v-on:dragleave="dragLeaveHandler($event)"
      v-on:dragover="dragOverHandler($event)"
      v-on:drop="dropHandler($event, 'into')"
    >
      <b-container>
        <b-row>
          <b-col cols="1" class="m-0 p-0 text-center">
            <b-form-checkbox
              v-model="visible"
              variant="info"
              switch
            ></b-form-checkbox>
          </b-col>

          <b-col cols="9" class="m-0 p-0" @click="toggle()">
            <span :id="'label_' + layer.id" class="truncate">
              <img :src="layer.svgIconUrl" v-if="layer.svgIconUrl && layer.svgIconUrl.length>0" style="width:25px"/>
              <b-icon icon="folder2-open" class="text-second" v-else></b-icon>
              {{ layer.title }} [{{ layer.childs.length }}]</span
            >
          </b-col>

          <b-col cols="2" class="m-0 p-0 text-right">
            <button
              class="btn btn-sm p-0 mx-0"
              @click="infoGroup()"
              v-b-tooltip.hover
              title="Configurer le groupe"
            >
              <b-icon icon="gear" variant="primary"></b-icon> &nbsp;
            </button>
            <button  v-if="contextService.isEditionActive" class="btn btn-sm p-0"
              style="margin-right:6px;"
              @click="deleteGroup()" v-b-tooltip.hover title="Supprimer le groupe">
                <b-icon icon="trash" variant="danger"></b-icon> &nbsp;
              </button>
          </b-col>
        </b-row>
      </b-container>
    </div>
    <div class="layer-group" v-bind:hidden="collapsed">
      <div v-for="layerElement in childs" :key="layerElement.id">
        <div class="layer-group-item">
          <GroupLayerElement
            v-if="layerElement.isGroup()"
            v-bind:layer="layerElement"
          ></GroupLayerElement>
          <SingleLayerElement
            v-if="!layerElement.isGroup()"
            v-bind:layer="layerElement"
          ></SingleLayerElement>
        </div>
      </div>
    </div>
    <div
      class="not_dragging"
      :class="{ dragging: showDropTarget() }"
      v-on:dragenter="dragEnterHandler($event)"
      v-on:dragleave="dragLeaveHandler($event)"
      v-on:dragover="dragOverHandler($event)"
      v-on:drop="dropHandler($event, 'after')"
    ></div>
  </div>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable no-use-before-define */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Component from 'vue-class-component';
import SingleLayerElement from '@/components/layers/SingleLayerElement.vue';
import LayerGroupConfig from '@/models/map-context/LayerGroupConfig';
import BaseComponent from '../BaseComponent';

@Component({
  name: 'GroupLayerElement',
  props: {
    layer: LayerGroupConfig,
  },
  components: {
    SingleLayerElement,
    GroupLayerElement,
  },
})
export default class GroupLayerElement extends BaseComponent {
  layer!: LayerGroupConfig;

  collapsed = false;

  get childs() {
    return this.layer.childs;
  }

  get visible(): boolean {
    return this.layer.visible;
  }

  set visible(visibility: boolean) {
    this.layer.setVisible(!this.layer.visible);
  }

  isFirstElementInTree() {
    return (
      this.contextService.getCurrentContext().getLayers()[0] === this.layer
      || (this.layer.parent !== undefined
        && this.layer.parent.childs[0] === this.layer)
    );
  }

  isEmptyGroup() {
    return this.layer.childs.length === 0;
  }

  dragstartHandler(event: any): void {
    console.log('drag start');
    this.contextService.setDraggingLayer(this.layer);
    event.dataTransfer.setData('text/plain', this.layer.id);
    event.dataTransfer.effectAllowed = 'move'; // only allow moves
  }

  showDropTarget(): boolean {
    return (
      this.contextService.getDraggingLayer() !== null
      && this.contextService.getDraggingLayer() !== this.layer
    );
  }

  dragendHandler(event: any): void {
    event.preventDefault();
    console.log('drag group end');
    this.contextService.setDraggingLayer(null);
  }

  dropHandler(event: any, dropLocation: string) {
    event.preventDefault();
    // console.log('drop end');
    console.log(`drop ${dropLocation} ${this.layer.title}`);
    const dragLayer = this.contextService.getDraggingLayer();
    if (dragLayer !== null && dragLayer !== this.layer) {
      this.getMapService().changeLayerOrder(dragLayer, this.layer, dropLocation);
    }
  }

  dragEnterHandler(event: any) {
    event.preventDefault();
    // console.log('drag enter');
    // console.log(event);
    if (event.target !== undefined && event.target.style !== undefined) {
      event.target.classList.add('overed');
    }
  }

  dragLeaveHandler(event: any) {
    event.preventDefault();
    // console.log('drag leave');
    // console.log(event);
    if (event.target !== undefined && event.target.style !== undefined) {
      event.target.classList.remove('overed');
    }
  }

  dragOverHandler(event: any) {
    event.preventDefault();
    // console.log('drag over');
    if (event.dataTransfer !== null) {
      event.dataTransfer.dropEffect = 'move';
    }
  }

  infoGroup() {
    this.contextService.setCurrentAction('infoGroup', this.layer);
  }

  deleteGroup(): void {
    this.getMapService().removeGroupFromList(this.layer);
  }

  onChange(): void {
    this.layer.setVisible(!this.layer.visible);
  }

  toggle(): void {
    this.collapsed = !this.collapsed;
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.layer-group-item {
  margin-left: 25px;
  background-color: white;
}

.not_dragging {
  display: none;
}
.dragging {
  display: block;
  background-color: lightgray;
  height: 3px;
}
.overed{
  color:@first;
  font-weight: bold;
}
</style>
